<?php

namespace \Liberty\Service\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cotizadorCabeceraResponse StructType
 * @subpackage Structs
 */
class CotizadorCabeceraResponse extends AbstractStructBase
{
    /**
     * The codRetorno
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $codRetorno;
    /**
     * The detalleResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \\Liberty\Service\StructType\CotizadorDetalleResponse[]
     */
    public $detalleResponse;
    /**
     * The mensajeRetorno
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mensajeRetorno;
    /**
     * Constructor method for cotizadorCabeceraResponse
     * @uses CotizadorCabeceraResponse::setCodRetorno()
     * @uses CotizadorCabeceraResponse::setDetalleResponse()
     * @uses CotizadorCabeceraResponse::setMensajeRetorno()
     * @param int $codRetorno
     * @param \\Liberty\Service\StructType\CotizadorDetalleResponse[] $detalleResponse
     * @param string $mensajeRetorno
     */
    public function __construct($codRetorno = null, array $detalleResponse = array(), $mensajeRetorno = null)
    {
        $this
            ->setCodRetorno($codRetorno)
            ->setDetalleResponse($detalleResponse)
            ->setMensajeRetorno($mensajeRetorno);
    }
    /**
     * Get codRetorno value
     * @return int|null
     */
    public function getCodRetorno()
    {
        return $this->codRetorno;
    }
    /**
     * Set codRetorno value
     * @param int $codRetorno
     * @return \\Liberty\Service\StructType\CotizadorCabeceraResponse
     */
    public function setCodRetorno($codRetorno = null)
    {
        // validation for constraint: int
        if (!is_null($codRetorno) && !(is_int($codRetorno) || ctype_digit($codRetorno))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codRetorno, true), gettype($codRetorno)), __LINE__);
        }
        $this->codRetorno = $codRetorno;
        return $this;
    }
    /**
     * Get detalleResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \\Liberty\Service\StructType\CotizadorDetalleResponse[]|null
     */
    public function getDetalleResponse()
    {
        return isset($this->detalleResponse) ? $this->detalleResponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDetalleResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDetalleResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDetalleResponseForArrayConstraintsFromSetDetalleResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $cotizadorCabeceraResponseDetalleResponseItem) {
            // validation for constraint: itemType
            if (!$cotizadorCabeceraResponseDetalleResponseItem instanceof \\Liberty\Service\StructType\CotizadorDetalleResponse) {
                $invalidValues[] = is_object($cotizadorCabeceraResponseDetalleResponseItem) ? get_class($cotizadorCabeceraResponseDetalleResponseItem) : sprintf('%s(%s)', gettype($cotizadorCabeceraResponseDetalleResponseItem), var_export($cotizadorCabeceraResponseDetalleResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The detalleResponse property can only contain items of type \\Liberty\Service\StructType\CotizadorDetalleResponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set detalleResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \\Liberty\Service\StructType\CotizadorDetalleResponse[] $detalleResponse
     * @return \\Liberty\Service\StructType\CotizadorCabeceraResponse
     */
    public function setDetalleResponse(array $detalleResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($detalleResponseArrayErrorMessage = self::validateDetalleResponseForArrayConstraintsFromSetDetalleResponse($detalleResponse))) {
            throw new \InvalidArgumentException($detalleResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($detalleResponse) || (is_array($detalleResponse) && empty($detalleResponse))) {
            unset($this->detalleResponse);
        } else {
            $this->detalleResponse = $detalleResponse;
        }
        return $this;
    }
    /**
     * Add item to detalleResponse value
     * @throws \InvalidArgumentException
     * @param \\Liberty\Service\StructType\CotizadorDetalleResponse $item
     * @return \\Liberty\Service\StructType\CotizadorCabeceraResponse
     */
    public function addToDetalleResponse(\\Liberty\Service\StructType\CotizadorDetalleResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \\Liberty\Service\StructType\CotizadorDetalleResponse) {
            throw new \InvalidArgumentException(sprintf('The detalleResponse property can only contain items of type \\Liberty\Service\StructType\CotizadorDetalleResponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->detalleResponse[] = $item;
        return $this;
    }
    /**
     * Get mensajeRetorno value
     * @return string|null
     */
    public function getMensajeRetorno()
    {
        return $this->mensajeRetorno;
    }
    /**
     * Set mensajeRetorno value
     * @param string $mensajeRetorno
     * @return \\Liberty\Service\StructType\CotizadorCabeceraResponse
     */
    public function setMensajeRetorno($mensajeRetorno = null)
    {
        // validation for constraint: string
        if (!is_null($mensajeRetorno) && !is_string($mensajeRetorno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mensajeRetorno, true), gettype($mensajeRetorno)), __LINE__);
        }
        $this->mensajeRetorno = $mensajeRetorno;
        return $this;
    }
}
